"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const core_1 = require("@collectable/core");
const internals_1 = require("../internals");
const size_1 = require("./size");
function filter(fn, map) {
    var nextSet = core_1.modify(map);
    var { _indexed: keyMap, _sorted: sortedValues, } = nextSet;
    var it = internals_1.iterate(map);
    var current;
    var index = 0, remaining = size_1.size(map);
    while (!(current = it.next()).done) {
        var entry = current.value;
        if (!fn(entry.value, entry.key, index++)) {
            remaining--;
            internals_1.unsetItem(entry.key, keyMap, sortedValues);
        }
    }
    if (remaining <= 0) {
        return map;
    }
    core_1.commit(nextSet);
    if (core_1.isImmutable(map)) {
        return nextSet;
    }
    map._indexed = keyMap;
    map._sorted = sortedValues;
    return map;
}
exports.filter = filter;

//# sourceMappingURL=filter.js.map
